=== debian/changelog ===
libgmpada (1.1-3) unstable; urgency=medium

  * Debhelper 11.
  * Drop obsolete version restriction on dpkg-dev.
  * Standards-Version 4.1.4.
  * Update URI syntax of VCS-Mtn field.
  * Disable tests if DEB_BUILD_OPTIONS contains nocheck.
  * Increase verbosity of run time test.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 03 May 2018 17:59:51 +0200

libgmpada (1.1-2) unstable; urgency=medium

  * Upload to unstable. Change versions: SO (runtime) and ALI (-dev).
  * Standards-Version: 4.0.1. Priority: optional.
  * Drop explicit rules targets confusing dh.

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 09 Aug 2017 19:54:28 +0200

libgmpada (1.1-1) experimental; urgency=medium

  * New upstream built with gnat-7. No ALI/SO change in experimental.
    Drop dependency on mpfr and kfreebsd-amd64-gnat6-bug-in-test.diff.
  * Drop -pie from explicit hardening flags.
  * Standards-Version: 4.0.0. HTTPS version of copyright-format URL.
  * Debhelper 10.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 06 Jul 2017 12:56:40 +0200
