=== debian/control ===
Source: libgmpada
Section: libdevel
Priority: optional
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends: debhelper (>= 11),
 gnat, gnat-7,
# This line is parsed by debian/rules.
 dh-ada-library (>= 6.7),
# dh-ada-library >= 6.7 stops requiring -dbg packages.
 libgmp-dev
Standards-Version: 4.1.4
Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
Vcs-Mtn: mtn://www.ada-france.org?org.debian.libgmpada
Homepage: http://nicolas.boulenguez.free.fr

Package: libgmpada7-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends},
 libgmp-dev
Description: Ada binding to the GNU MultiPrecision library: development
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats.
 .
 Install this package if you want to write programs that
 use libgmpada.

Package: libgmpada5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada binding to the GNU MultiPrecision library: shared library
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats.
 .
 This package contains the runtime shared library.
