=== debian/rules ===
#!/usr/bin/make -f

$(foreach line,$(shell sed -n '\
  s/^ gnat, gnat-\([0-9.]\+\),$$/ \
    GNAT_VERSION:=\1 \
  /p;\
  s/^Package: lib[a-z-]\+\([0-9.]\+\)$$/ \
    SOVERSION:=\1 \
  /p;\
  ' debian/control),$(eval $(line)))

DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/default.mk
include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk

%:
	dh $@ --with ada-library

.PHONY: override_dh_auto_build
override_dh_auto_build:
  # -gnatn is very useful for the thin binding.
	dh_auto_build -- \
	  $(foreach v,CFLAGS CPPFLAGS LDFLAGS SOVERSION,$(v)='$($(v))') \
	  ADAFLAGS='$(ADAFLAGS) -gnatn' \
	  GNATMAKE_OPTIONS='$(BUILDER_OPTIONS)'

.PHONY: override_dh_auto_test
override_dh_auto_test:
  ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test -- \
	  $(foreach v,CFLAGS CPPFLAGS LDFLAGS SOVERSION,$(v)='$($(v))') \
	  ADAFLAGS='$(ADAFLAGS) -gnata' \
	  GNATMAKE_OPTIONS='$(BUILDER_OPTIONS)'
  endif

# Ignore this target from upstream Makefile.
.PHONY: override_dh_auto_install

.PHONY: override_dh_compress
override_dh_compress:
	dh_compress --all $(addprefix --exclude=,.ads .adb Makefile .c .h)
