## libgmpada 1.2

=== Makefile ===
--- 
+++ 
@@ -52,6 +52,7 @@
 ifneq ($(words $(CC)),1)
  $(error Failed to set CC from gnatmake output.)
 endif
+CXX := $(subst cc,++,$(CC))
 
 LDLIBS := -lgmp
 
@@ -80,8 +81,8 @@
 #########
 
 ada_bodies      := $(wildcard src/*.adb)
-ada_specs       := src/gmp-constants.ads \
-  $(filter-out src/gmp-constants.ads,$(wildcard src/*.ads))
+ada_specs       := src/gmp-h.ads \
+  $(filter-out src/gmp-h.ads,$(wildcard src/*.ads))
 ada_units       := $(ada_bodies) $(filter-out $(ada_bodies:b=s),$(ada_specs))
 C_SOURCES       := $(wildcard src/*.c)
 C_OBJ_DYNAMIC   := $(patsubst src/%.c,obj-dynamic/%.o,$(C_SOURCES))
@@ -119,15 +120,15 @@
           ,-e "s|@$(d)_DIR@|`realpath -m $($(d)_DIR) --relative-to=$(GPR_DIR)`|") \
           $< > $@
 
-src/gmp-constants.ads: obj/generate_constants | obj
-	$< > $@
-obj/generate_constants: generate_constants.c | obj
-	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) $< $(LDLIBS) -o $@
+src/gmp-h.ads: gmp-h.ads.sed | obj
+	echo '#include <gmp.h>' > obj/tmp.h
+	cd obj && $(CXX) --dump-ada-spec tmp.h
+	sed -f $< obj/*_gmp_h.ads > $@
 
 obj obj-dynamic obj-static:
 	mkdir $@
 clean::
-	rm -f src/gmp-constants.ads
+	rm -f src/gmp-h.ads
 	rm -fr obj obj-dynamic obj-static
 	find -name "*~" -delete
