=== debian/changelog ===
libgmpada (1.2-2) unstable; urgency=medium

  * Rebuild in unstable for gnat-8 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 27 Oct 2018 15:09:55 +0200

libgmpada (1.2-1) experimental; urgency=medium

  * New upstream release. Rebuild with gnat-8, gcc-8.
    Rename shared library and -dev package per Debian Ada policy.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 08 May 2018 14:01:35 +0200
