=== debian/control ===
--- 
+++ 
@@ -3,8 +3,10 @@
 Priority: optional
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends: debhelper (>= 11),
- gnat, gnat-7,
+ gnat, gnat-8,
 # This line is parsed by debian/rules.
+ g++-8,
+# The same version is required to generate the thin binding.
  dh-ada-library (>= 6.7),
 # dh-ada-library >= 6.7 stops requiring -dbg packages.
  libgmp-dev
@@ -13,7 +15,7 @@
 Vcs-Mtn: mtn://www.ada-france.org?org.debian.libgmpada
 Homepage: http://nicolas.boulenguez.free.fr
 
-Package: libgmpada7-dev
+Package: libgmpada8-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends},
  libgmp-dev
@@ -25,7 +27,7 @@
  Install this package if you want to write programs that
  use libgmpada.
 
-Package: libgmpada5
+Package: libgmpada6
 Section: libs
 Architecture: any
 Multi-Arch: same
