=== debian/rules ===
--- 
+++ 
@@ -26,12 +26,12 @@
 
 .PHONY: override_dh_auto_test
 override_dh_auto_test:
-  ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	dh_auto_test -- \
 	  $(foreach v,CFLAGS CPPFLAGS LDFLAGS SOVERSION,$(v)='$($(v))') \
 	  ADAFLAGS='$(ADAFLAGS) -gnata' \
 	  GNATMAKE_OPTIONS='$(BUILDER_OPTIONS)'
-  endif
+endif
 
 # Ignore this target from upstream Makefile.
 .PHONY: override_dh_auto_install
