## libgmpada 1.3

=== Makefile ===
--- 
+++ 
@@ -30,6 +30,7 @@
 # CFLAGS and LDFLAGS.
 CPPFLAGS ?=
 CFLAGS   ?= -O2
+CXXFLAGS ?=
 ADAFLAGS ?= -O2 -gnatn
 # Inlining helps a lot for the thin binding.
 LDFLAGS  ?=
@@ -122,7 +123,7 @@
 
 src/gmp-h.ads: gmp-h.ads.sed | obj
 	echo '#include <gmp.h>' > obj/tmp.h
-	cd obj && $(CXX) --dump-ada-spec tmp.h
+	cd obj && $(CXX) $(CPPFLAGS) $(CXXFLAGS) --dump-ada-spec tmp.h
 	sed -f $< obj/*_gmp_h.ads > $@
 
 obj obj-dynamic obj-static:
