=== debian/changelog ===
libgmpada (1.3-2) unstable; urgency=medium

  * Reupload to unstable for gnat-9 transition. Closes: #944185.
  * Debhelper 12: dh-sequence syntax, examples are not compressed.
  * Standards-Version 4.5.0.
  * Drop redundant branch in Vcs-Git.
  * Drop explicit --as-needed, enabled by default by gcc-9.
  * Select specific dpkg-dev Makefile snippet.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 25 Feb 2020 11:53:20 +0100

libgmpada (1.3-1) experimental; urgency=medium

  * New upstream release, built with gnat-9.
    Migration in experimental, renaming lib and -dev packages.
  * Move Version Control System to salsa.
  * Standards-Version 4.4.0.
  * Rules-Requires-Root no.
  * Debhelper 12.
  * Remove unused signatures from upstream/signing-key.asc.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 18 Jul 2019 14:07:22 +0200
