=== debian/control ===
--- 
+++ 
@@ -2,20 +2,21 @@
 Section: libdevel
 Priority: optional
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
-Build-Depends: debhelper (>= 11),
- gnat, gnat-8,
+Build-Depends:
+ debhelper-compat (= 12),
+ dh-sequence-ada-library,
+ gnat, gnat-9,
 # This line is parsed by debian/rules.
- g++-8,
+ g++-9,
 # The same version is required to generate the thin binding.
- dh-ada-library (>= 6.7),
-# dh-ada-library >= 6.7 stops requiring -dbg packages.
- libgmp-dev
-Standards-Version: 4.1.4
-Vcs-Browser: http://www.ada-france.org:8081/branch/changes/org.debian.libgmpada
-Vcs-Mtn: mtn://www.ada-france.org?org.debian.libgmpada
+ libgmp-dev,
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
+Vcs-Browser: https://salsa.debian.org/debian/libgmpada
+Vcs-Git: https://salsa.debian.org/debian/libgmpada.git
 Homepage: http://nicolas.boulenguez.free.fr
 
-Package: libgmpada8-dev
+Package: libgmpada9-dev
 Architecture: any
 Depends: ${misc:Depends}, ${ada:Depends},
  libgmp-dev
@@ -27,7 +28,7 @@
  Install this package if you want to write programs that
  use libgmpada.
 
-Package: libgmpada6
+Package: libgmpada7
 Section: libs
 Architecture: any
 Multi-Arch: same
