=== debian/rules ===
--- 
+++ 
@@ -10,11 +10,13 @@
   ' debian/control),$(eval $(line)))
 
 DEB_BUILD_MAINT_OPTIONS := hardening=+all
-include /usr/share/dpkg/default.mk
+DEB_LDFLAGS_MAINT_APPEND := -Wl,--no-undefined \
+  -Wl,--no-copy-dt-needed-entries -Wl,--no-allow-shlib-undefined
+include /usr/share/dpkg/buildflags.mk
 include /usr/share/ada/debian_packaging-$(GNAT_VERSION).mk
 
 %:
-	dh $@ --with ada-library
+	dh $@
 
 .PHONY: override_dh_auto_build
 override_dh_auto_build:
@@ -35,7 +37,3 @@
 
 # Ignore this target from upstream Makefile.
 .PHONY: override_dh_auto_install
-
-.PHONY: override_dh_compress
-override_dh_compress:
-	dh_compress --all $(addprefix --exclude=,.ads .adb Makefile .c .h)
