## libgmpada 1.4

=== Makefile ===
#    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
#    Copyright (C) 2007-2020 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

########################
# Global configuration #
########################

LIB_NAME := gmpada

SOVERSION := 2

################################
# Build and test configuration #
################################

# For build flags:
# * settings from the environment are appended and take precedence.
# * Settings from the command line fully replace the default.

# Option for the Ada compiler
ADAFLAGS := -g -O2 -gnataEfnoqQ -gnatVa -Wall -Wextra -gnatw.eH.Y \
  -gnatyBdIoOSuxy $(ADAFLAGS)

# Options for the C and C++ preprocessors
CPPFLAGS ?=

# Options for the C compiler
CFLAGS := -g -O2 -Wall -Wextra -pedantic $(CFLAGS)

# Options for the C++ compiler
CXXFLAGS := -Wall -Wextra $(CXXFLAGS)

# Options for the linker
LDFLAGS := -Wl,--as-needed -Wl,--no-allow-shlib-undefined \
  -Wl,--no-copy-dt-needed-entries -Wl,--no-undefined $(LDFLAGS)

# Options for gnatmake
GNATMAKE_OPTIONS ?=

# We want the same compiler for C, C++ and Ada, so the default value
# from Make is not sufficient.  The following works on Debian but will
# probably require a command line override in other contexts.
CC := $(shell gnatmake --version \
  | sed -E 's/^GNATMAKE (([0-9]+)\.[0-9]+).*/gcc-\1 gcc-\2/; q' \
  | xargs which)
ifneq ($(words $(CC)),1)
 $(error Failed to set CC from gnatmake output.)
endif
CXX := $(patsubst gcc-%,g++-%,$(CC))

# Objects for the linker (FOO.o, libFOO.a, libFOO.so or -lFOO)
# The order may matter with --as-needed.
LDLIBS := -lgmp $(LDLIBS)

##############################
# Installation configuration #
##############################

prefix              := /usr
datarootdir         := $(prefix)/share
libdir              := $(prefix)/lib

# The sources files are installed into a LIB_NAME subdirectory of
SRC_DIR             := $(datarootdir)/ada/adainclude

# A LIB_NAME.gpr project convenient for library usage is installed into
GPR_DIR             := $(datarootdir)/gpr

# The content of this file ignores DESTDIR.
# The GNAT ALI files are installed into a LIB_NAME subdirectory of
ALI_DIR             := $(libdir)/ada/adalib

# The static archive is installed into
A_DIR               := $(libdir)

# The shared library is installed into
SO_DIR              := $(libdir)

# DESTDIR allows staged installs. It is prefixed to actual
# installation paths but ignored otherwise.

#########
# Rules #
#########

ada_bodies      := $(wildcard src/*.adb)
ada_specs       := src/gmp-h.ads \
  $(filter-out src/gmp-h.ads,$(wildcard src/*.ads))
ada_units       := $(ada_bodies) $(filter-out $(ada_bodies:b=s),$(ada_specs))
C_SOURCES       := $(wildcard src/*.c)
C_OBJ_DYNAMIC   := $(patsubst src/%.c,obj-dynamic/%.o,$(C_SOURCES))
C_OBJ_STATIC    := $(patsubst src/%.c,obj-static/%.o, $(C_SOURCES))

# Default target is:
.PHONY: build
build: obj/lib$(LIB_NAME).so.$(SOVERSION) \
       obj/lib$(LIB_NAME).a \
       obj/$(LIB_NAME).gpr

obj/lib$(LIB_NAME).so.$(SOVERSION): $(ada_bodies) $(ada_specs) $(C_OBJ_DYNAMIC) | obj
	gnatmake -c $(ada_units) -D obj-dynamic $(GNATMAKE_OPTIONS) \
          -cargs $(ADAFLAGS) -fPIC
	$(CC) -shared -o $@ -Wl,-soname,lib$(LIB_NAME).so.$(SOVERSION) \
	  obj-dynamic/*.o $(LDFLAGS) -lgnat $(LDLIBS)

obj/lib$(LIB_NAME).a: $(ada_bodies) $(ada_specs) $(C_OBJ_STATIC) | obj
	gnatmake -c $(ada_units) -D obj-static $(GNATMAKE_OPTIONS) \
          -cargs $(ADAFLAGS)
	ar cr $@ obj-static/*.o
	ranlib $@

$(C_OBJ_DYNAMIC): obj-dynamic/%.o: src/%.c | obj-dynamic
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@ -fPIC

$(C_OBJ_STATIC): obj-static/%.o: src/%.c | obj-static
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@

obj/$(LIB_NAME).gpr: template_for_installed_project
	sed \
          -e '/@LDLIBS@/{s||$(patsubst %,"%",$(LDLIBS))|;s/" "/", "/g}' \
	  $(foreach v,ALI_DIR LIB_NAME SO_DIR SRC_DIR,-e "s|@$(v)@|$($(v))|") \
          $< > $@

src/gmp-h.ads: gmp-h.ads.sed | obj
	echo '#include <gmp.h>' > obj/tmp.h
	cd obj && $(CXX) $(CPPFLAGS) $(CXXFLAGS) --dump-ada-spec tmp.h
	sed -f $< obj/*_gmp_h.ads > $@

obj obj-dynamic obj-static:
	mkdir $@
clean::
	rm -f src/gmp-h.ads
	rm -fr obj obj-dynamic obj-static
	find -name "*~" -delete

######################################################################
.PHONY: test
test: | demo-dynamic demo-static
	$(MAKE) install DESTDIR=demo-install

	gnatmake demo.adb -o demo-dynamic/demo -D demo-dynamic $(GNATMAKE_OPTIONS) \
	  -aIdemo-install$(SRC_DIR)/$(LIB_NAME) \
	  -aOdemo-install$(ALI_DIR)/$(LIB_NAME) \
	  -cargs $(ADAFLAGS) -gnata \
	  -largs $(LDFLAGS) demo-install$(SO_DIR)/lib$(LIB_NAME).so $(LDLIBS)
	LD_LIBRARY_PATH=demo-install$(SO_DIR) demo-dynamic/demo

	gnatmake demo.adb -o demo-static/demo -D demo-static $(GNATMAKE_OPTIONS) \
	  -aIdemo-install$(SRC_DIR)/$(LIB_NAME) \
	  -aOdemo-install$(ALI_DIR)/$(LIB_NAME) \
	  -cargs $(ADAFLAGS) -gnata \
	  -largs $(LDFLAGS) demo-install$(A_DIR)/lib$(LIB_NAME).a $(LDLIBS)
	demo-static/demo

	$(MAKE) uninstall DESTDIR=demo-install
	test `find demo-install -type f | wc -l` = 0

demo-dynamic demo-static:
	mkdir $@
clean::
	rm -f b~demo.adb b~demo.ads b~demo.ali b~demo.o
	rm -fr demo-dynamic demo-install demo-static

######################################################################
.PHONY: install
install: build
	install -m644 -Dt$(DESTDIR)$(SRC_DIR)/$(LIB_NAME) $(ada_bodies) $(ada_specs) $(C_SOURCES)
	install -m644 -Dt$(DESTDIR)$(GPR_DIR) obj/$(LIB_NAME).gpr
	install -m444 -Dt$(DESTDIR)$(ALI_DIR)/$(LIB_NAME) obj-dynamic/*.ali
	install -m644 -Dt$(DESTDIR)$(A_DIR) obj/lib$(LIB_NAME).a
	install -m644 -Dt$(DESTDIR)$(SO_DIR) obj/lib$(LIB_NAME).so.$(SOVERSION)
	ln -fs lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so

.PHONY: uninstall
uninstall:
	rm -fr $(DESTDIR)$(SRC_DIR)/$(LIB_NAME) \
	       $(DESTDIR)$(ALI_DIR)/$(LIB_NAME)
	rm -f  $(DESTDIR)$(GPR_DIR)/$(LIB_NAME).gpr \
	       $(DESTDIR)$(A_DIR)/lib$(LIB_NAME).a \
	       $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so.$(SOVERSION) \
	       $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so

######################################################################
.PHONY: clean
