=== debian/changelog ===
libgmpada (1.4-4) unstable; urgency=medium

  * Reupload to unstable for the gnat-11 transition
  * Configure branch names for git-buildpackage
  * Require dh-ada-library 7.5, which generates ada:Depends differently

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 08 May 2022 18:22:26 +0200

libgmpada (1.4-3) experimental; urgency=medium

  * Rebuild with gnat-11. Rename -dev package accordingly.
  * Standards-Version 4.6.0.
  * Adapt to changes in debian_packaging.mk.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 13 Mar 2022 22:00:20 +0000

libgmpada (1.4-2) unstable; urgency=medium

  * Reupload to unstable for gnat-10 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 13 Dec 2020 12:09:59 +0100

libgmpada (1.4-1) experimental; urgency=medium

  * Build with gnat-10. Rename lib and -dev package accordingly.
  * New upstream release.
  * Pass build flags via the environment
  * Refresh debhelper usage.
    No need to mention README.Debian in debian/docs anymore
    Drop obsolete Pre-Depends
  * Refresh dh-ada-library usage.
    Drop explicit dependency on libgmp-dev, now in ada:Depends.
    Move -lgmp from Library_Options to Linker_Options.

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 22 May 2020 00:30:12 +0000
