=== debian/control ===
Source: libgmpada
Section: libdevel
Priority: optional
Maintainer: Nicolas Boulenguez <nicolas@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 dh-ada-library (>= 7.5),
 dh-sequence-ada-library,
 gnat,
 gnat-11,
 g++-11,
# The same version is required to generate the thin binding.
 libgmp-dev,
Standards-Version: 4.6.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/libgmpada
Vcs-Git: https://salsa.debian.org/debian/libgmpada.git
Homepage: http://nicolas.boulenguez.free.fr

Package: libgmpada11-dev
Architecture: any
Depends: ${misc:Depends}, ${ada:Depends}
Description: Ada binding to the GNU MultiPrecision library: development
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats.
 .
 Install this package if you want to write programs that
 use libgmpada.

Package: libgmpada8
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Ada binding to the GNU MultiPrecision library: shared library
 GMPAda allows programmers to use the GNU MultiPrecision library
 within the Ada language: unbounded integers, rationals and
 floats.
 .
 This package contains the runtime shared library.
