=== debian/rules ===
#!/usr/bin/make -f

SOVERSION != \
  sed -n '/^Package: libgmpada\([0-9.]\+\)$$/{s//\1/p;q}' debian/control

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/buildopts.mk
include /usr/share/ada/debian_packaging.mk

%:
	dh $@

.PHONY: override_dh_auto_build
override_dh_auto_build:
	dh_auto_build -- \
	  SOVERSION=$(SOVERSION) \
	  GNATMAKE_OPTIONS='$(GNATMAKEFLAGS)'

.PHONY: override_dh_auto_test
override_dh_auto_test:
	dh_auto_test -- \
	  SOVERSION=$(SOVERSION) \
	  GNATMAKE_OPTIONS='$(GNATMAKEFLAGS)'

# Ignore this target from upstream Makefile.
.PHONY: override_dh_auto_install
