## libgmpada 1.5

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #    GMPAda, binding to the Ada Language for the GNU MultiPrecision library.
-#    Copyright (C) 2007-2020 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
+#    Copyright (C) 2007-2022 Nicolas Boulenguez <nicolas.boulenguez@free.fr>
 #
 #    This program is free software: you can redistribute it and/or modify
 #    it under the terms of the GNU General Public License as published by
@@ -50,6 +50,10 @@
 # Options for gnatmake
 GNATMAKE_OPTIONS ?=
 
+# A -j option in GNATMAKEFLAGS will be more efficient and produce
+# readable logs. Never allow make -j to interfer.
+.NOTPARALLEL:
+
 # We want the same compiler for C, C++ and Ada, so the default value
 # from Make is not sufficient.  The following works on Debian but will
 # probably require a command line override in other contexts.
