=== debian/changelog ===
libgmpada (1.5-7) unstable; urgency=medium

  * Break/Replace libgmpada*-dev since oldstable. Closes: #1034960.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 11 May 2023 00:39:45 +0200

libgmpada (1.5-6) unstable; urgency=medium

  * Mark the autopkgtest as flaky (#1026828 affects them on i386).

 -- Nicolas Boulenguez <nicolas@debian.org>  Wed, 04 Jan 2023 14:11:32 +0000

libgmpada (1.5-5) unstable; urgency=medium

  * Disable post-build tests on i386. Ugly, but #1026828 (severity normal)
    should not force libgmpada out of the bookworm release.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 02 Jan 2023 16:10:45 +0000

libgmpada (1.5-4) unstable; urgency=medium

  * Downgrade the test sometimes failing after the build on i386
    (#1026828) to a non-critical message.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sat, 31 Dec 2022 15:08:53 +0100

libgmpada (1.5-3) unstable; urgency=medium

  * Let -dev depend on libgmp-dev (previously done by dh-ada-library).

 -- Nicolas Boulenguez <nicolas@debian.org>  Fri, 30 Dec 2022 18:53:13 +0000

libgmpada (1.5-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-12 transition.
  * Standards-Version: 4.6.2 (no changes).
  * Explicitly install docs to -dev package.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 27 Dec 2022 02:39:16 +0100

libgmpada (1.5-1) experimental; urgency=medium

  * Build new upstream in experimental with gnat-12 and dh-ada-library 8.1.
    Rename -dev package but not shared library.
  * Standards-Version: 4.6.1

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 30 Aug 2022 10:04:13 +0000
