=== debian/control ===
--- 
+++ 
@@ -4,22 +4,23 @@
 Maintainer: Nicolas Boulenguez <nicolas@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- dh-ada-library (>= 7.5),
+ dh-ada-library (>= 8.1),
  dh-sequence-ada-library,
- gnat,
- gnat-11,
- g++-11,
+ gnat-12,
+ g++-12,
 # The same version is required to generate the thin binding.
  libgmp-dev,
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian/libgmpada
 Vcs-Git: https://salsa.debian.org/debian/libgmpada.git
 Homepage: http://nicolas.boulenguez.free.fr
 
-Package: libgmpada11-dev
+Package: libgmpada12-dev
+Breaks: libgmpada8-dev, libgmpada9-dev, libgmpada10-dev, libgmpada11-dev
+Replaces: libgmpada8-dev, libgmpada9-dev, libgmpada10-dev, libgmpada11-dev
 Architecture: any
-Depends: ${misc:Depends}, ${ada:Depends}
+Depends: ${misc:Depends}, ${ada:Depends}, libgmp-dev,
 Description: Ada binding to the GNU MultiPrecision library: development
  GMPAda allows programmers to use the GNU MultiPrecision library
  within the Ada language: unbounded integers, rationals and
