=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS := 1
DEB_BUILD_MAINT_OPTIONS := hardening=+all
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
include /usr/share/ada/packaging.mk

MAKE_OPTS := \
  SOVERSION=$(gmpada_SO_VERSION) \
  CC=gcc-$(DEB_GNAT_VERSION) \
  GNATMAKE_OPTIONS='$(GNATMAKEFLAGS)' \
  libdir=/$(DEB_LIB_DIR) \
  SRC_DIR=/$(DEB_ADA_SOURCE_DIR) \
  GPR_DIR=/$(DEB_GNAT_PROJECT_DIR) \
  ALI_DIR=/$(DEB_ADA_LIB_INFO_DIR) \
  # EOL

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- $(MAKE_OPTS)

override_dh_auto_test:
  # Prevent the build from failing on i386 because of #1026828.
  ifneq ($(DEB_HOST_ARCH),i386)
	dh_auto_test -- $(MAKE_OPTS)
  endif

override_dh_auto_install:
	dh_auto_install -- $(MAKE_OPTS)

execute_before_dh_installdocs:
	dh_installdocs --package=$(gmpada_DEV_PKG) README TODO

execute_before_dh_installexamples:
	dh_installexamples --package=$(gmpada_DEV_PKG) demo.adb
