## libgmpada 1.6

=== Makefile ===
--- 
+++ 
@@ -20,8 +20,6 @@
 
 LIB_NAME := gmpada
 
-SOVERSION := 2
-
 ################################
 # Build and test configuration #
 ################################
@@ -57,13 +55,10 @@
 # We want the same compiler for C, C++ and Ada, so the default value
 # from Make is not sufficient.  The following works on Debian but will
 # probably require a command line override in other contexts.
-CC := $(shell gnatmake --version \
-  | sed -E 's/^GNATMAKE (([0-9]+)\.[0-9]+).*/gcc-\1 gcc-\2/; q' \
-  | xargs which)
-ifneq ($(words $(CC)),1)
- $(error Failed to set CC from gnatmake output.)
-endif
-CXX := $(patsubst gcc-%,g++-%,$(CC))
+GNATMAKE            := gnatmake
+gnat_version := $(shell $(GNATMAKE) --version | sed 's/.* \([0-9]\+\).*/\1/;q')
+CC                  := gcc-$(gnat_version)
+CXX                 := g++-$(gnat_version)
 
 # Objects for the linker (FOO.o, libFOO.a, libFOO.so or -lFOO)
 # The order may matter with --as-needed.
@@ -81,6 +76,7 @@
 SRC_DIR             := $(datarootdir)/ada/adainclude
 
 # A LIB_NAME.gpr project convenient for library usage is installed into
+gnat_project        := $(LIB_NAME).gpr
 GPR_DIR             := $(datarootdir)/gpr
 
 # The content of this file ignores DESTDIR.
@@ -88,9 +84,14 @@
 ALI_DIR             := $(libdir)/ada/adalib
 
 # The static archive is installed into
+static_library      := lib$(LIB_NAME).a
 A_DIR               := $(libdir)
 
 # The shared library is installed into
+SOVERSION           := 2
+shared_object_name  := lib$(LIB_NAME).so.$(SOVERSION)
+shared_library      := $(shared_object_name)
+development_link    := lib$(LIB_NAME).so
 SO_DIR              := $(libdir)
 
 # DESTDIR allows staged installs. It is prefixed to actual
@@ -100,39 +101,39 @@
 # Rules #
 #########
 
-ada_bodies      := $(wildcard src/*.adb)
-ada_specs       := src/gmp-h.ads \
-  $(filter-out src/gmp-h.ads,$(wildcard src/*.ads))
-ada_units       := $(ada_bodies) $(filter-out $(ada_bodies:b=s),$(ada_specs))
-C_SOURCES       := $(wildcard src/*.c)
-C_OBJ_DYNAMIC   := $(patsubst src/%.c,obj-dynamic/%.o,$(C_SOURCES))
-C_OBJ_STATIC    := $(patsubst src/%.c,obj-static/%.o, $(C_SOURCES))
+ada_units := $(wildcard src/*.adb) \
+ src/gmp.ads \
+ src/gmp-h.ads \
+ src/gnu_multiple_precision-text_io.ads \
+ src/gnu_multiple_precision-wide_text_io.ads \
+ src/gnu_multiple_precision-wide_wide_text_io.ads
 
 # Default target is:
 .PHONY: build
-build: obj/lib$(LIB_NAME).so.$(SOVERSION) \
-       obj/lib$(LIB_NAME).a \
-       obj/$(LIB_NAME).gpr
-
-obj/lib$(LIB_NAME).so.$(SOVERSION): $(ada_bodies) $(ada_specs) $(C_OBJ_DYNAMIC) | obj
-	gnatmake -c $(ada_units) -D obj-dynamic $(GNATMAKE_OPTIONS) \
+build: obj/$(shared_library) obj/$(static_library) obj/$(gnat_project)
+
+# Phony so that GNATMAKE deals with Ada dependencies, not MAKE.
+.PHONY: obj/$(shared_library)
+obj/$(shared_library): src/gmp-h.ads obj-dynamic/gmp_macros.o | obj obj-dynamic
+	$(GNATMAKE) -c $(ada_units) -D obj-dynamic $(GNATMAKE_OPTIONS) \
           -cargs $(ADAFLAGS) -fPIC
-	$(CC) -shared -o $@ -Wl,-soname,lib$(LIB_NAME).so.$(SOVERSION) \
+	$(CC) -shared -o $@ -Wl,-soname,$(shared_object_name) \
 	  obj-dynamic/*.o $(LDFLAGS) -lgnat $(LDLIBS)
 
-obj/lib$(LIB_NAME).a: $(ada_bodies) $(ada_specs) $(C_OBJ_STATIC) | obj
-	gnatmake -c $(ada_units) -D obj-static $(GNATMAKE_OPTIONS) \
+.PHONY: obj/$(static_library)
+obj/$(static_library): src/gmp-h.ads obj-static/gmp_macros.o | obj obj-static
+	$(GNATMAKE) -c $(ada_units) -D obj-static $(GNATMAKE_OPTIONS) \
           -cargs $(ADAFLAGS)
 	ar cr $@ obj-static/*.o
 	ranlib $@
 
-$(C_OBJ_DYNAMIC): obj-dynamic/%.o: src/%.c | obj-dynamic
+obj-dynamic/gmp_macros.o: src/gmp_macros.c | obj-dynamic
 	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@ -fPIC
 
-$(C_OBJ_STATIC): obj-static/%.o: src/%.c | obj-static
+obj-static/gmp_macros.o: src/gmp_macros.c | obj-static
 	$(CC) -c $(CPPFLAGS) $(CFLAGS) $< -o $@
 
-obj/$(LIB_NAME).gpr: template_for_installed_project
+obj/$(gnat_project): template_for_installed_project | obj
 	sed \
           -e '/@LDLIBS@/{s||$(patsubst %,"%",$(LDLIBS))|;s/" "/", "/g}' \
 	  $(foreach v,ALI_DIR LIB_NAME SO_DIR SRC_DIR,-e "s|@$(v)@|$($(v))|") \
@@ -142,6 +143,8 @@
 	echo '#include <gmp.h>' > obj/tmp.h
 	cd obj && $(CXX) $(CPPFLAGS) $(CXXFLAGS) --dump-ada-spec tmp.h
 	sed -f $< obj/*_gmp_h.ads > $@
+  # Uncomment this when debugging a new version
+  #	diff -u obj/*_gmp_h.ads $@ | less
 
 obj obj-dynamic obj-static:
 	mkdir $@
@@ -155,18 +158,20 @@
 test: | demo-dynamic demo-static
 	$(MAKE) install DESTDIR=demo-install
 
-	gnatmake demo.adb -o demo-dynamic/demo -D demo-dynamic $(GNATMAKE_OPTIONS) \
+	$(GNATMAKE) demo.adb \
+	  -o demo-dynamic/demo -D demo-dynamic $(GNATMAKE_OPTIONS) \
 	  -aIdemo-install$(SRC_DIR)/$(LIB_NAME) \
 	  -aOdemo-install$(ALI_DIR)/$(LIB_NAME) \
 	  -cargs $(ADAFLAGS) -gnata \
-	  -largs $(LDFLAGS) demo-install$(SO_DIR)/lib$(LIB_NAME).so $(LDLIBS)
+	  -largs $(LDFLAGS) demo-install$(SO_DIR)/$(development_link) $(LDLIBS)
 	LD_LIBRARY_PATH=demo-install$(SO_DIR) demo-dynamic/demo
 
-	gnatmake demo.adb -o demo-static/demo -D demo-static $(GNATMAKE_OPTIONS) \
+	$(GNATMAKE) demo.adb \
+	  -o demo-static/demo -D demo-static $(GNATMAKE_OPTIONS) \
 	  -aIdemo-install$(SRC_DIR)/$(LIB_NAME) \
 	  -aOdemo-install$(ALI_DIR)/$(LIB_NAME) \
 	  -cargs $(ADAFLAGS) -gnata \
-	  -largs $(LDFLAGS) demo-install$(A_DIR)/lib$(LIB_NAME).a $(LDLIBS)
+	  -largs $(LDFLAGS) demo-install$(A_DIR)/$(static_library) $(LDLIBS)
 	demo-static/demo
 
 	$(MAKE) uninstall DESTDIR=demo-install
@@ -181,21 +186,21 @@
 ######################################################################
 .PHONY: install
 install: build
-	install -m644 -Dt$(DESTDIR)$(SRC_DIR)/$(LIB_NAME) $(ada_bodies) $(ada_specs) $(C_SOURCES)
-	install -m644 -Dt$(DESTDIR)$(GPR_DIR) obj/$(LIB_NAME).gpr
+	install -m644 -Dt$(DESTDIR)$(SRC_DIR)/$(LIB_NAME) src/*
+	install -m644 -Dt$(DESTDIR)$(GPR_DIR) obj/$(gnat_project)
 	install -m444 -Dt$(DESTDIR)$(ALI_DIR)/$(LIB_NAME) obj-dynamic/*.ali
-	install -m644 -Dt$(DESTDIR)$(A_DIR) obj/lib$(LIB_NAME).a
-	install -m644 -Dt$(DESTDIR)$(SO_DIR) obj/lib$(LIB_NAME).so.$(SOVERSION)
-	ln -fs lib$(LIB_NAME).so.$(SOVERSION) $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so
+	install -m644 -Dt$(DESTDIR)$(A_DIR) obj/$(static_library)
+	install -m644 -Dt$(DESTDIR)$(SO_DIR) obj/$(shared_library)
+	ln -fs $(shared_library) $(DESTDIR)$(SO_DIR)/$(development_link)
 
 .PHONY: uninstall
 uninstall:
 	rm -fr $(DESTDIR)$(SRC_DIR)/$(LIB_NAME) \
 	       $(DESTDIR)$(ALI_DIR)/$(LIB_NAME)
-	rm -f  $(DESTDIR)$(GPR_DIR)/$(LIB_NAME).gpr \
-	       $(DESTDIR)$(A_DIR)/lib$(LIB_NAME).a \
-	       $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so.$(SOVERSION) \
-	       $(DESTDIR)$(SO_DIR)/lib$(LIB_NAME).so
+	rm -f  $(DESTDIR)$(GPR_DIR)/$(gnat_project) \
+	       $(DESTDIR)$(A_DIR)/$(static_library) \
+	       $(DESTDIR)$(SO_DIR)/$(shared_library) \
+	       $(DESTDIR)$(SO_DIR)/$(development_link)
 
 ######################################################################
 .PHONY: clean
