=== debian/changelog ===
libgmpada (1.6-4build1) questing; urgency=medium

  * No-change rebuild for gnat ABI, triggered by glibc 2.42.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 21 Sep 2025 07:46:22 +0200

libgmpada (1.6-4) unstable; urgency=medium

  * Reupload to unstable for the gnat-14 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Mon, 10 Mar 2025 14:18:55 +0100

libgmpada (1.6-3) experimental; urgency=medium

  * Build with gnat-14
  * Add comments to gbp.conf
  * Update Standards-Version and copyright years.

 -- Nicolas Boulenguez <nicolas@debian.org>  Thu, 02 Jan 2025 14:40:59 +0100

libgmpada (1.6-2) unstable; urgency=medium

  * Reupload to unstable for the gnat-13/time_t64 transition.

 -- Nicolas Boulenguez <nicolas@debian.org>  Sun, 17 Mar 2024 20:36:42 +0100

libgmpada (1.6-1) experimental; urgency=medium

  * New upstream release.
  * Upload to experimental because of the following transitions.
  * Build with gnat-13.  Rename library package with new SOversion.
  * Build with dh-ada-library/9. Remove version from -dev package name.
    Provide a name containing a hash.
    Build-Depend: gnat instead of gnat-13. Break/Replace previous -devs.
  * Use explicit debian/PACKAGE.{docs,examples} files and test
    dependencies now that the -dev package is unversioned.

 -- Nicolas Boulenguez <nicolas@debian.org>  Tue, 26 Dec 2023 20:38:38 +0000
