=== debian/tests/control ===
Tests: link-with-shared
Depends: gprbuild, libgmpada-dev
# Fails on i386 buildds, autopkgtest runners, but not on the porterbox.
# https://bugs.debian.org/1026828
Restrictions: flaky
