=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ \
  http://nicolas.boulenguez.free.fr \
  @PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@
